<script lang="ts">
    import {Todo, Todos} from '../../models';
    import {TodoProxyService} from '../../services';

    let todos: Todos;
    let loading = true;
    let edit = false;
    let editTodoId = '';
    let error = '';
    const todoProxy = new TodoProxyService();

    getAllTodos();

    function getAllTodos() {
        // Get all todos from the API
        todoProxy.getAllTodos().then(response => response.json())
            .then((result: Todos) => {
                todos = result;
                loading = false;
            }).catch((err) => {
            console.log(err);
            loading = false;
        });
    }

    function handleEdit(uuid: string) {
        edit = true;
        editTodoId = uuid;
    }

    function cancelEdit() {
        edit = false;
        editTodoId = '';
    }

    function handleDelete(deleteTodoId: string) {
        if (confirm('Are you sure you want to delete this?')) {
            // Delete todo by id (deleteTodoId)
            todoProxy.deleteTodo(deleteTodoId).then((result) => {
                location.href = '/todos';
            });
        }
    }

    function saveEdit(todo: Todo) {
        // Edit the todo (id = editTodoId variable)
        todoProxy.patchTodoById(todo.uuid, todo).then((result) => {
            cancelEdit();
            getAllTodos();
        }).catch((err) => {
            console.log(err);
        });
    }
</script>

<svelte:head>
    <title>Svelte Todo app</title>
</svelte:head>

<div class="todos-list">
    {#if todos && !error && !loading}
        {#each todos.data as todo}
            {#if todo.uuid === editTodoId}
                <div class="todo-edit-item">
                    <div class="todo-edit-input">
                        <input type="text" bind:value={todo.title}/>
                        <textarea rows="4" bind:value={todo.message}></textarea>
                    </div>
                    <div class="todo-actions">
                        <button on:click={cancelEdit}>Cancel</button>
                        <button on:click={saveEdit(todo)}>Save changes</button>
                    </div>
                </div>
            {:else }
                <div class="todo-item">
                    <a href="/todos/{todo.uuid}">
                        <div class="title-section">
                            <p>{todo.title}</p>
                        </div>
                        <p>{todo?.message}</p>
                    </a>
                    <div class="todo-actions">
                        <button on:click={handleDelete(todo.uuid)}>Delete</button>
                        <button on:click={handleEdit(todo.uuid)}>Edit</button>
                    </div>
                </div>
            {/if}
        {/each}
    {/if}
</div>

<style>
    .todos-list {
        margin-top: 80px;
        margin-left: 30%;
        margin-right: 30%;
    }

    .todos-list a {
        color: inherit;
        text-decoration: none;
    }

    .todos-list .todo-item, .todos-list .todo-edit-item {
        display: flex;
        justify-content: space-between;
        margin-top: 20px;
        border-radius: 10px;
        background-color: #f3f3f3;
        padding: 4px 20px;
    }

    .todos-list .todo-edit-item .todo-edit-input {
        padding: 3px;
    }

    .todos-list .todo-edit-item .todo-edit-input input, textarea {
        max-width: 500px;
        width: 90%;
        border-radius: 8px;
        border: 1px solid #b0b0b0;
        height: 23px;
        padding-left: 9px;
        color: #111;
        font-size: .85rem;
        background-color: #f3f3f3;
        margin-top: 10px;
    }

    .todos-list .todo-edit-item .todo-edit-input textarea {
        max-width: 500px;
        width: 90%;
        height: 75px;
    }

    .todos-list .todo-actions {
        margin-top: auto;
    }

    .todos-list .todo-actions button {
        border: none;
        cursor: pointer;
        float: right;
        border-radius: 8px;
        padding: 4px 10px;
        color: #fff;
        font-size: .95rem;
    }

    .todos-list .todo-actions button:hover {
        opacity: .83;
    }

    .todos-list .todo-actions button:first-of-type {
        background-color: #e12727;
    }

    .todos-list .todo-actions button:last-of-type {
        background-color: #55be32;
    }

    .todos-list .todo-item .title-section p:first-of-type {
        font-size: 1.3rem;
        margin: 2px 0 4px;
    }

    .todos-list .todo-item .title-section .written-by p {
        font-size: .9rem;
    }

    @media (max-width: 768px) {
        .todos-list {
            margin-left: 20px;
            margin-right: 20px;
        }
    }
</style>
